/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __AI_MATH_H__
#define __AI_MATH_H__

#include "3dmath/Vector.h"
#include "convergence/DungeonRoomModel.h"
#include "convergence/GameObjectModel.h"
#include <stdlib.h>

struct travelPath {
	size_t nodeCount;
	int * nodes;
};

GameObjectModel ** AIObjectsInLineOfSight(Vector2 referencePoint,
                                          Vector2 direction,
                                          float fov,
                                          float distance,
                                          struct DungeonTile * tiles,
                                          size_t tileCountX,
                                          size_t tileCountY,
                                          GameObjectModel ** gameObjects,
                                          size_t gameObjectCount,
                                          size_t * outObjectCount);
struct travelPath AIBestPathToDestination(int origin,
                                          int destination,
                                          struct DungeonTile * tiles,
                                          size_t tileCountX,
                                          size_t tileCountY);

#endif
