/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __CHOOSE_CLASS_STATE_H__
#define __CHOOSE_CLASS_STATE_H__

typedef struct ChooseClassState ChooseClassState;

#include "glbitmapfont/GLBitmapFont.h"
#include "statecontroller/State.h"
#include "convergence/GameSession.h"

#define ChooseClassState_structContents \
	State_structContents \
	\
	GameSession * gameSession; \
	GLBitmapFont * font; \
	int selectedItemIndex;

struct ChooseClassState {
	ChooseClassState_structContents
};

ChooseClassState * ChooseClassState_create(GameSession * gameSession);
void ChooseClassState_init(compat_type(ChooseClassState *) selfPtr, GameSession * gameSession);
void ChooseClassState_dispose(compat_type(ChooseClassState *) selfPtr);

void ChooseClassState_activate(compat_type(ChooseClassState *) selfPtr);
void ChooseClassState_deactivate(compat_type(ChooseClassState *) selfPtr);
void ChooseClassState_draw(compat_type(ChooseClassState *) selfPtr);

#endif
