/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __DUNGEON_DOOR_MODEL_H__
#define __DUNGEON_DOOR_MODEL_H__

typedef struct DungeonDoorModel DungeonDoorModel;

#include "convergence/GameObjectModel.h"

#define DUNGEON_DOOR_EVENT_UNLOCKED "DUNGEON_DOOR_EVENT_UNLOCKED"

#define DungeonDoorModel_structContents \
	GameObjectModel_structContents \
	\
	int keyID; \
	struct rect4f bounds;

struct DungeonDoorModel {
	DungeonDoorModel_structContents
};

DungeonDoorModel * DungeonDoorModel_create(DungeonRoomStateModel * stateModel, int keyID, struct rect4f bounds);
void DungeonDoorModel_init(compat_type(DungeonDoorModel *) selfPtr, DungeonRoomStateModel * stateModel, int keyID, struct rect4f bounds);
void DungeonDoorModel_initCopy(compat_type(GameObjectModel *) selfPtr, compat_type(GameObjectModel *) originalPtr);
void DungeonDoorModel_dispose(compat_type(DungeonDoorModel *) selfPtr);

compat_type(DungeonDoorModel *) DungeonDoorModel_copy(compat_type(DungeonDoorModel *) selfPtr);
bool DungeonDoorModel_wouldCollide(compat_type(DungeonDoorModel *) selfPtr, compat_type(GameObjectModel *) objectPtr);
struct rect4f DungeonDoorModel_roughBounds(compat_type(DungeonDoorModel *) selfPtr);
struct collisionGeometry DungeonDoorModel_collisionGeometry(compat_type(DungeonDoorModel *) selfPtr);
void DungeonDoorModel_collision(compat_type(DungeonDoorModel *) selfPtr, compat_type(GameObjectModel *) objectPtr, const struct collision collision, float time);

#endif
