/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __ENEMY_BERSERKER_MODEL_H__
#define __ENEMY_BERSERKER_MODEL_H__

typedef struct EnemyBerserkerModel EnemyBerserkerModel;

#include "convergence/EnemyModel.h"

#define EnemyBerserkerModel_structContents \
	EnemyModel_structContents \
	\
	int attackCooldown; \
	Direction swordSwingFacing;

struct EnemyBerserkerModel {
	EnemyBerserkerModel_structContents
};

EnemyBerserkerModel * EnemyBerserkerModel_create(DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyBerserkerModel_init(compat_type(EnemyBerserkerModel *) selfPtr, DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyBerserkerModel_initCopy(compat_type(EnemyBerserkerModel *) selfPtr, compat_type(EnemyBerserkerModel *) originalPtr);
void EnemyBerserkerModel_dispose(compat_type(EnemyBerserkerModel *) selfPtr);

compat_type(EnemyBerserkerModel *) EnemyBerserkerModel_copy(compat_type(EnemyBerserkerModel *) selfPtr);
void EnemyBerserkerModel_update(compat_type(EnemyBerserkerModel *) selfPtr);
void EnemyBerserkerModel_aiUpdate(compat_type(EnemyBerserkerModel *) selfPtr);
bool EnemyBerserkerModel_atRest(compat_type(EnemyBerserkerModel *) selfPtr);
void EnemyBerserkerModel_setAIState(compat_type(EnemyBerserkerModel *) selfPtr, enum EnemyAIState state);
void EnemyBerserkerModel_attack(compat_type(EnemyBerserkerModel *) selfPtr);

#endif
