/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __ENEMY_RANGER_MODEL_H__
#define __ENEMY_RANGER_MODEL_H__

typedef struct EnemyRangerModel EnemyRangerModel;

#include "convergence/EnemyModel.h"

#define EnemyRangerModel_structContents \
	EnemyModel_structContents \
	\
	int attackCooldown; \
	int shotsBeforeReposition; \
	int repositionUpdatesRemaining;

struct EnemyRangerModel {
	EnemyRangerModel_structContents
};

EnemyRangerModel * EnemyRangerModel_create(DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyRangerModel_init(compat_type(EnemyRangerModel *) selfPtr, DungeonRoomStateModel * stateModel, int rank, Vector2 position, Direction facing, size_t inventoryItemCount, struct InventoryModel_item * inventoryItems, size_t patrolWaypointCount, Vector2 * patrolWaypoints);
void EnemyRangerModel_initCopy(compat_type(EnemyRangerModel *) selfPtr, compat_type(EnemyRangerModel *) originalPtr);
void EnemyRangerModel_dispose(compat_type(EnemyRangerModel *) selfPtr);

compat_type(EnemyRangerModel *) EnemyRangerModel_copy(compat_type(EnemyRangerModel *) selfPtr);
void EnemyRangerModel_update(compat_type(EnemyRangerModel *) selfPtr);
void EnemyRangerModel_aiUpdate(compat_type(EnemyRangerModel *) selfPtr);
bool EnemyRangerModel_atRest(compat_type(EnemyRangerModel *) selfPtr);
void EnemyRangerModel_setAIState(compat_type(EnemyRangerModel *) selfPtr, enum EnemyAIState state);
void EnemyRangerModel_attack(compat_type(EnemyRangerModel *) selfPtr);

#endif
