/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __GAME_STATE_CONTROLLER_H__
#define __GAME_STATE_CONTROLLER_H__

typedef struct GameStateController GameStateController;

#include "convergence/DungeonModel.h"
#include "convergence/GameSession.h"
#include "convergence/GameStateModel.h"
#include "stemobject/StemObject.h"
#include <stdbool.h>

#define GameStateController_structContents \
	StemObject_structContents \
	\
	GameStateModel * model; \
	\
	void (* update)(compat_type(GameStateController *) self); \
	bool (* atRest)(compat_type(GameStateController *) self);

struct GameStateController {
	GameStateController_structContents
};

GameStateController * GameStateController_create(GameStateModel * model);
void GameStateController_init(compat_type(GameStateController *) selfPtr, GameStateModel * model);
void GameStateController_dispose(compat_type(GameStateController *) selfPtr);

void GameStateController_startDungeon(compat_type(GameStateController *) selfPtr, DungeonModel * dungeon, enum PlayerClass playerClass);
void GameStateController_update(compat_type(GameStateController *) selfPtr);
bool GameStateController_atRest(compat_type(GameStateController *) selfPtr);

#endif
