/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __INSTRUCTIONS_CLASS_STATE_H__
#define __INSTRUCTIONS_CLASS_STATE_H__

typedef struct InstructionsState InstructionsState;

#include "glbitmapfont/GLBitmapFont.h"
#include "statecontroller/State.h"
#include "convergence/GameSession.h"

#define InstructionsState_structContents \
	State_structContents \
	\
	GameSession * gameSession; \
	GLBitmapFont * font;

struct InstructionsState {
	InstructionsState_structContents
};

InstructionsState * InstructionsState_create(GameSession * gameSession);
void InstructionsState_init(compat_type(InstructionsState *) selfPtr, GameSession * gameSession);
void InstructionsState_dispose(compat_type(InstructionsState *) selfPtr);

void InstructionsState_activate(compat_type(InstructionsState *) selfPtr);
void InstructionsState_deactivate(compat_type(InstructionsState *) selfPtr);
void InstructionsState_draw(compat_type(InstructionsState *) selfPtr);

#endif
