/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYER_BERSERKER_MODEL_H__
#define __PLAYER_BERSERKER_MODEL_H__

typedef struct PlayerBerserkerModel PlayerBerserkerModel;

#include "convergence/PlayerModel.h"

#define PlayerBerserkerModel_structContents \
	PlayerModel_structContents \
	\
	int attackCooldown; \
	Direction swordSwingFacing;

struct PlayerBerserkerModel {
	PlayerBerserkerModel_structContents
};

PlayerBerserkerModel * PlayerBerserkerModel_create(DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerBerserkerModel_init(compat_type(PlayerBerserkerModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerBerserkerModel_initCopy(compat_type(PlayerBerserkerModel *) selfPtr, compat_type(PlayerBerserkerModel *) originalPtr);
void PlayerBerserkerModel_dispose(compat_type(PlayerBerserkerModel *) selfPtr);

compat_type(PlayerBerserkerModel *) PlayerBerserkerModel_copy(compat_type(PlayerBerserkerModel *) selfPtr);
void PlayerBerserkerModel_update(compat_type(PlayerBerserkerModel *) selfPtr);
bool PlayerBerserkerModel_atRest(compat_type(PlayerBerserkerModel *) selfPtr);
void PlayerBerserkerModel_startAttack(compat_type(PlayerBerserkerModel *) selfPtr);

#endif
