/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __PLAYER_SPEEDSTER_MODEL_H__
#define __PLAYER_SPEEDSTER_MODEL_H__

typedef struct PlayerSpeedsterModel PlayerSpeedsterModel;

#include "convergence/PlayerModel.h"

#define PlayerSpeedsterModel_structContents \
	PlayerModel_structContents \
	\
	int attackCooldown; \
	int dashDamage; \
	float dashKnockback;

struct PlayerSpeedsterModel {
	PlayerSpeedsterModel_structContents
};

PlayerSpeedsterModel * PlayerSpeedsterModel_create(DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerSpeedsterModel_init(compat_type(PlayerSpeedsterModel *) selfPtr, DungeonRoomStateModel * stateModel, Vector2 position, Direction facing);
void PlayerSpeedsterModel_initCopy(compat_type(PlayerSpeedsterModel *) selfPtr, compat_type(PlayerSpeedsterModel *) originalPtr);
void PlayerSpeedsterModel_dispose(compat_type(PlayerSpeedsterModel *) selfPtr);

compat_type(PlayerSpeedsterModel *) PlayerSpeedsterModel_copy(compat_type(PlayerSpeedsterModel *) selfPtr);
void PlayerSpeedsterModel_update(compat_type(PlayerSpeedsterModel *) selfPtr);
bool PlayerSpeedsterModel_atRest(compat_type(PlayerSpeedsterModel *) selfPtr);
void PlayerSpeedsterModel_collisionInternal(compat_type(PlayerModel *) selfPtr, compat_type(GameObjectModel *) objectPtr, const struct collision collision, float time);
void PlayerSpeedsterModel_startAttack(compat_type(PlayerSpeedsterModel *) selfPtr);
void PlayerSpeedsterModel_knockedBack(compat_type(PlayerSpeedsterModel *) selfPtr, Vector2 knockback);

#endif
