/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __RECORDING_PLAYER_INPUT_CONTROLLER_H__
#define __RECORDING_PLAYER_INPUT_CONTROLLER_H__

typedef struct RecordingPlayerInputController RecordingPlayerInputController;

#define PLAYER_INPUT_SESSION_VERSION 0

#include "convergence/PlayerInputController.h"

struct RecordedPlayerInputNode {
	unsigned int frameIndex;
	Atom actionID;
	bool triggered;
};

#define RecordingPlayerInputController_structContents \
	PlayerInputController_structContents \
	\
	unsigned int frameCount; \
	size_t nodeCount; \
	size_t nodeListSize; \
	struct RecordedPlayerInputNode * nodes; \
	\
	void (* save)(compat_type(RecordingPlayerInputController *) self, const char * fileName);

struct RecordingPlayerInputController {
	RecordingPlayerInputController_structContents
};

RecordingPlayerInputController * RecordingPlayerInputController_create(PlayerModel * playerModel, PlayerInputMap * inputMap);
void RecordingPlayerInputController_init(compat_type(RecordingPlayerInputController *) selfPtr, PlayerModel * playerModel, PlayerInputMap * inputMap);
void RecordingPlayerInputController_dispose(compat_type(RecordingPlayerInputController *) selfPtr);

bool RecordingPlayerInputController_triggerAction(compat_type(RecordingPlayerInputController *) selfPtr, Atom actionID);
bool RecordingPlayerInputController_releaseAction(compat_type(RecordingPlayerInputController *) selfPtr, Atom actionID);
void RecordingPlayerInputController_update(compat_type(RecordingPlayerInputController *) selfPtr);
void RecordingPlayerInputController_save(compat_type(RecordingPlayerInputController *) selfPtr, const char * fileName);

#endif
