/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __SPLASH_SCREEN_STATE_H__
#define __SPLASH_SCREEN_STATE_H__

typedef struct SplashScreenState SplashScreenState;

#include "glbitmapfont/GLBitmapFont.h"
#include "statecontroller/State.h"
#include "convergence/GameSession.h"

#define SplashScreenState_structContents \
	State_structContents \
	\
	GameSession * gameSession; \
	GLBitmapFont * font; \
	int selectedItemIndex;

struct SplashScreenState {
	SplashScreenState_structContents
};

SplashScreenState * SplashScreenState_create(GameSession * gameSession);
void SplashScreenState_init(compat_type(SplashScreenState *) selfPtr, GameSession * gameSession);
void SplashScreenState_dispose(compat_type(SplashScreenState *) selfPtr);

void SplashScreenState_activate(compat_type(SplashScreenState *) selfPtr);
void SplashScreenState_deactivate(compat_type(SplashScreenState *) selfPtr);
void SplashScreenState_draw(compat_type(SplashScreenState *) selfPtr);

#endif
