/*
  Copyright (c) 2011 Alex Diener
  
  This software is provided 'as-is', without any express or implied
  warranty. In no event will the authors be held liable for any damages
  arising from the use of this software.
  
  Permission is granted to anyone to use this software for any purpose,
  including commercial applications, and to alter it and redistribute it
  freely, subject to the following restrictions:
  
  1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.
  
  Alex Diener adiener@sacredsoftware.net
*/

#ifndef __TEXTURE_CANVAS_H__
#define __TEXTURE_CANVAS_H__

typedef struct TextureCanvas TextureCanvas;

#define TEXTURE_CANVAS_SERIALIZATION_FORMAT_VERSION 0

#include "convergence/SharedDefinitions.h"
#include "stemobject/StemObject.h"
#include "utilities/Atom.h"
#include <stdlib.h>

struct TextureCanvas_tile {
	Atom name;
	struct rect4f bounds;
};

#define TextureCanvas_structContents \
	StemObject_structContents \
	\
	char * textureFileName; \
	size_t tileCount; \
	struct TextureCanvas_tile * tiles;

struct TextureCanvas {
	TextureCanvas_structContents
};

TextureCanvas * TextureCanvas_create();
void TextureCanvas_init(compat_type(TextureCanvas *) selfPtr);
void TextureCanvas_dispose(compat_type(TextureCanvas *) selfPtr);

TextureCanvas * TextureCanvas_deserialize(compat_type(DeserializationContext *) deserializationContext);
bool TextureCanvas_loadSerializedData(compat_type(TextureCanvas *) selfPtr, compat_type(DeserializationContext *) deserializationContext);
void TextureCanvas_serialize(compat_type(TextureCanvas *) selfPtr, compat_type(SerializationContext *) serializationContext);

#endif
